;
;                         16 bit Trainer For Minesweeper
;                         ------------------------------
;                                Copyright by Gij
;
; This skeleton of this is ripped. 
;
; Use the included Batch File file to Assemble.
;
; How to Use It: 
;                 run minesweeper, click any block, run this trainer 
; 
; Features: (1) Auto-Adjusts to MineField Height/Width ( gets data from memory )
;           (2) makes a nice beep when the message box pops up  
;
;
; You are free to modify/use it for any non-commercial purpose, meaning you 
; don't get money off this.
; If you do use it, remember, giving credit where credit is due is l33t.
;
;
; If You need to contact me, i can often be found on EFNET's #cracking4newbies
;
;          learn and enjoy.
;
; Greets go to:
; 	Stone:   for pointing me in the direction of toolhelp for doing this,
;                And writing great articles and code.
;
;       Natzgul: For publishing his "Writing to process memory" article.
;	|Fresh|: Helping me find some info.
;
;	Nasm Development Team:
;                For Writing My favorite assembler, that can do almost anything.                 
;
; And to All the Guys And Gals on #c4n, cause they're all so damn newbie :-) .
;
;
; [Gij/98]

extern 	 INITTASK
extern   MESSAGEBOX

extern   TASKFIRST
extern   TASKNEXT
extern   TASKGETCSIP


SEGMENT _DATA CLASS=data

TIMES 16 db 0			  ; Filler for Windows Task manager.
                                  ;  This *MUST* be declared, otherwise
                                  ;  Windows will clobber part of your data
                                  ;  segment.  For additional information on
                                  ;  Windows Task managment and what
                                  ;  happens when Windows apps start up, see
                                  ;  "Windows Internals" - Matt Pietrek,
                                  ;  1993 Addison Wesley
psp         dw 0
pszCmdline  dw 0
hPrev       dw 0
hInstance   dw 0
cmdShow     dw 0

newhwnd     dw 0
mbx_count   dw 0


; This Struct Is TASKENTRY, from toolhelp.h, used by TASKNEXT AND TASKFIRST

tEntry:
.te_dwSize		dd 28h  
.te_hTask  		dw 0       
.te_hTaskParent		dw 0      
.te_hInst      		dw 0     
.te_hModule    		dw 0     
.te_wSS        		dw 0      
.te_wSP        		dw 0     
.te_wStackTop  		dw 0      
.te_wStackMinimum 	dw 0   
.te_wStackBottom  	dw 0    
.te_wcEvents      	dw 0    
.te_hQueue        	dw 0     
.te_szModule      	TIMES 10 db 0   
.te_wPSPOffset    	dw 0    
.te_hNext         	dw 0   

Target_Name db "WINMINE",0
Target_Name_Len equ 8


szCapt          db 'MineSweeper Watch By Gij',0
Suc_Msg1	db "Found Target's Task Entry. Click Me.",0
Fail_Msg1 	db "Unable To Find Target's Task Entry, Sorry.",0


Max_Height EQU 30
Max_Width  EQU 24

Width_Location  equ 1f8h
Height_Location equ 1fah
Field_Location  equ 460h

; We Copy The field in here, and make it into a string for our messagebox
Mine_Field resb Max_Width*Max_Height+Max_Height*2

SEGMENT _TEXT CLASS=CODE

.286
;-----------------------------------------------------------------------------
..start:

                mov     ax, seg psp
                mov     ds, ax           ; set up data segment
		mov 	es, ax
;Windows initialization.  Sets up registers and stack.

                ;INITTASK returns:
                ;  Failure:
                ;    AX = zero if it failed
                ;  Success:
                ;    AX = 1
                ;    CX = stack limit
                ;    DX = cmdShow parameter to CreateWindow
                ;    ES:BX = -> DOS format command line (ES = PSP address)
                ;    SI = hPrevinstance
                ;    DI = hinstance

                call far INITTASK
                or      ax,ax
                jnz     .OK
                jmp     Exit
.OK:            mov     [psp],es
                mov     word  [pszCmdline],bx
                mov     [hPrev],si
                mov     [hInstance],di
                mov     [cmdShow],dx


Walk_Task_List:
		push ds
		push word tEntry
		call far TASKFIRST
		
Find_Target_Entry:
		mov cx,Target_Name_Len
		mov si,tEntry.te_szModule
		mov di,Target_Name
		repz cmpsb
		jz Found_Entry
			
Get_Next_Entry:	
		push ds
		push word tEntry
		call far TASKNEXT
		or ax,ax
		jnz Find_Target_Entry
		jmp Entry_Search_Failed

Found_Entry:
                push    word 0
                push    ds
                push    word Suc_Msg1
                push    ds
                push    word szCapt
                push    word 0
                call    far MESSAGEBOX        ; put up msgbox and wait

;		int 3

		push 	word [tEntry.te_hTask]
		call	far TASKGETCSIP


display:
		call 	clear_minefield
		nop
		nop
		call	read_minefield		


		push es  ; save es, destroyed by MESSAGEBOX

                push    word 0
                push    ds
                push    word  Mine_Field
                push    ds
                push    word  szCapt
		push 	word 0

                call far MESSAGEBOX        ; put up msgbox and wait

		pop ax
		mov es,ax

;		jmp display	
		jmp Exit

Entry_Search_Failed:
                push    word 0
                push    ds
                push    word Fail_Msg1
                push    ds
                push    word szCapt
                push    word 0
                call far MESSAGEBOX        ; put up msgbox and wait

Exit:
                mov    ah, 4Ch
                int    21h


;**********************

clear_minefield:

	push es

	mov ax,SEG psp
	mov es,ax
	mov di,Mine_Field

	mov cx,Max_Height*Max_Width+3
	xor al,al
	repz stosb

	pop ax
	mov es,ax

	ret

;**********************

read_minefield:

	mov di,Mine_Field

	mov bx,1

out_loop:
	push bx
	shl bx,5

	mov si,1

inner_loop:

	test byte  [es:460h+bx+si],80h
	jz not_mine

	mov byte  [di],'0'
	jmp reloop

not_mine:
	mov byte  [di],'1'
	
reloop:
	inc di
	inc si
	cmp si,[es:Width_Location]

	jle inner_loop


	mov word [di],0a0dh
	add di,2
	pop bx
	inc bx
	cmp bx,[es:Height_Location]
	jle out_loop

	ret

; snip